import React from 'react'
import { connect } from 'react-redux'
import { sayHello } from '../actions'
import { globalIncrement, globalDecrement } from '../actions/index'
import { addItem, removeitem } from '../actions/index';
import productData from '../data';
import data from '../data'


let Button = ({ 
  globalDecrement ,
  globalIncrement ,
  count=0, 
  whatsUp, 
  stateObject, 
  saySomething,
  addItem,
  removeItem,
  cart
 }) => {


  return(
    <div >
    <button onClick={saySomething}>PRESS TO DISPATCH FIRST ACTION</button>
    <h2>{whatsUp}</h2>
    <button onClick={() => console.log('Redux State:',stateObject)} >Press to inspect STATE in console panel</button>

    <h2>Global Counter: {count}</h2>
    <button onClick={globalIncrement}>Increment</button>
    <button onClick={globalDecrement}>Decrement</button>

    <h1>Shop</h1>
    {productData.variants.map(item =>(
    <div>
      <div>
        { item.description }
      </div>
      <div>
        Inventory: { item.inventory }
      </div>
      <button onClick={ addItem }>ADD TO CART</button>
      <button onClick={ removeItem }>Remove Item</button>

    </div>
    ))}

    <h1>Cart</h1>
    {cart.map(item =>(
      <div>
        {item}
      </div>
    ))}
  </div>
  )
 }

  





const mapStateToProps = (state) => ({
  whatsUp: state.say,
  count: state.count,
  stateObject: state,
  cart: state.cart,
  productData: state.productData,

})

const mapDispatchToProps = (dispatch) => ({
  saySomething: () => { dispatch(sayHello())},
  globalIncrement: () => { dispatch(globalIncrement())},
  globalDecrement: () => { dispatch(globalDecrement())},
  addItem: product => {dispatch(addItem(product))},
  removeitem: product => {dispatch(removeitem(product))},

})

Button = connect(
  mapStateToProps,
  mapDispatchToProps
)(Button)

export default Button;
